Index: uspace/srv/net/tcp/test.c
===================================================================
--- uspace/srv/net/tcp/test.c	(revision fc7bf198e20e68849d91546bbc5a2a24c943840e)
+++ uspace/srv/net/tcp/test.c	(revision cf3aee195010da61f58b4c6e8daa8d03620c0a4e)
@@ -1,4 +1,4 @@
 /*
- * Copyright (c) 2011 Jiri Svoboda
+ * Copyright (c) 2015 Jiri Svoboda
  * All rights reserved.
  *
@@ -50,6 +50,5 @@
 {
 	tcp_conn_t *conn;
-	tcp_sock_t lsock;
-	tcp_sock_t fsock;
+	inet_ep2_t epp;
 	char rcv_buf[RCV_BUF_SIZE + 1];
 	size_t rcvd;
@@ -57,13 +56,15 @@
 
 	printf("test_srv()\n");
-	
-	inet_addr(&lsock.addr, 127, 0, 0, 1);
-	lsock.port = 80;
-	
-	inet_addr(&fsock.addr, 127, 0, 0, 1);
-	fsock.port = 1024;
-	
+
+	inet_ep2_init(&epp);
+
+	inet_addr(&epp.local.addr, 127, 0, 0, 1);
+	epp.local.port = 80;
+
+	inet_addr(&epp.remote.addr, 127, 0, 0, 1);
+	epp.remote.port = 1024;
+
 	printf("S: User open...\n");
-	tcp_uc_open(&lsock, &fsock, ap_passive, 0, &conn);
+	tcp_uc_open(&epp, ap_passive, 0, &conn);
 	conn->name = (char *) "S";
 
@@ -93,19 +94,20 @@
 {
 	tcp_conn_t *conn;
-	tcp_sock_t lsock;
-	tcp_sock_t fsock;
+	inet_ep2_t epp;
 	const char *msg = "Hello World!";
 
 	printf("test_cli()\n");
-	
-	inet_addr(&lsock.addr, 127, 0, 0, 1);
-	lsock.port = 1024;
-	
-	inet_addr(&fsock.addr, 127, 0, 0, 1);
-	fsock.port = 80;
+
+	inet_ep2_init(&epp);
+
+	inet_addr(&epp.local.addr, 127, 0, 0, 1);
+	epp.local.port = 1024;
+
+	inet_addr(&epp.remote.addr, 127, 0, 0, 1);
+	epp.remote.port = 80;
 
 	async_usleep(1000*1000*3);
 	printf("C: User open...\n");
-	tcp_uc_open(&lsock, &fsock, ap_active, 0, &conn);
+	tcp_uc_open(&epp, ap_active, 0, &conn);
 	conn->name = (char *) "C";
 
Index: uspace/srv/net/tcp/tqueue.c
===================================================================
--- uspace/srv/net/tcp/tqueue.c	(revision fc7bf198e20e68849d91546bbc5a2a24c943840e)
+++ uspace/srv/net/tcp/tqueue.c	(revision cf3aee195010da61f58b4c6e8daa8d03620c0a4e)
@@ -1,4 +1,4 @@
 /*
- * Copyright (c) 2011 Jiri Svoboda
+ * Copyright (c) 2015 Jiri Svoboda
  * All rights reserved.
  *
@@ -282,10 +282,10 @@
 }
 
-void tcp_transmit_segment(tcp_sockpair_t *sp, tcp_segment_t *seg)
+void tcp_transmit_segment(inet_ep2_t *epp, tcp_segment_t *seg)
 {
 	log_msg(LOG_DEFAULT, LVL_DEBUG,
-	    "tcp_transmit_segment(f:(%u),l:(%u), %p)",
-	    sp->local.port, sp->foreign.port, seg);
-	
+	    "tcp_transmit_segment(l:(%u),f:(%u), %p)",
+	    epp->local.port, epp->remote.port, seg);
+
 	log_msg(LOG_DEFAULT, LVL_DEBUG, "SEG.SEQ=%" PRIu32 ", SEG.WND=%" PRIu32,
 	    seg->seq, seg->wnd);
@@ -301,5 +301,5 @@
 	tcp_pdu_t *pdu;
 
-	if (tcp_pdu_encode(sp, seg, &pdu) != EOK) {
+	if (tcp_pdu_encode(epp, seg, &pdu) != EOK) {
 		log_msg(LOG_DEFAULT, LVL_WARN, "Not enough memory. Segment dropped.");
 		return;
@@ -351,8 +351,8 @@
 
 	/* Reset retransmission timer */
-	tcp_tqueue_timer_set(tqe->conn);
+	fibril_timer_set_locked(conn->retransmit.timer, RETRANSMIT_TIMEOUT,
+	    retransmit_timeout_func, (void *) conn);
 
 	tcp_conn_unlock(conn);
-	tcp_conn_delref(conn);
 
 	log_msg(LOG_DEFAULT, LVL_DEBUG, "### %s: retransmit_timeout_func(%p) end", conn->name, conn);
Index: uspace/srv/net/tcp/tqueue.h
===================================================================
--- uspace/srv/net/tcp/tqueue.h	(revision fc7bf198e20e68849d91546bbc5a2a24c943840e)
+++ uspace/srv/net/tcp/tqueue.h	(revision cf3aee195010da61f58b4c6e8daa8d03620c0a4e)
@@ -1,4 +1,4 @@
 /*
- * Copyright (c) 2011 Jiri Svoboda
+ * Copyright (c) 2015 Jiri Svoboda
  * All rights reserved.
  *
@@ -36,4 +36,5 @@
 #define TQUEUE_H
 
+#include <inet/endpoint.h>
 #include "std.h"
 #include "tcp_type.h"
@@ -48,5 +49,5 @@
 extern void tcp_prepare_transmit_segment(tcp_conn_t *, tcp_segment_t *);
 extern void tcp_conn_transmit_segment(tcp_conn_t *, tcp_segment_t *);
-extern void tcp_transmit_segment(tcp_sockpair_t *, tcp_segment_t *);
+extern void tcp_transmit_segment(inet_ep2_t *, tcp_segment_t *);
 extern void tcp_header_setup(tcp_conn_t *, tcp_segment_t *, tcp_header_t *);
 extern void tcp_phdr_setup(tcp_conn_t *, tcp_segment_t *, tcp_phdr_t *);
Index: uspace/srv/net/tcp/ucall.c
===================================================================
--- uspace/srv/net/tcp/ucall.c	(revision fc7bf198e20e68849d91546bbc5a2a24c943840e)
+++ uspace/srv/net/tcp/ucall.c	(revision cf3aee195010da61f58b4c6e8daa8d03620c0a4e)
@@ -1,4 +1,4 @@
 /*
- * Copyright (c) 2011 Jiri Svoboda
+ * Copyright (c) 2015 Jiri Svoboda
  * All rights reserved.
  *
@@ -35,4 +35,5 @@
  */
 
+#include <errno.h>
 #include <fibril_synch.h>
 #include <io/log.h>
@@ -50,6 +51,5 @@
 /** OPEN user call
  *
- * @param lsock		Local socket
- * @param fsock		Foreign socket
+ * @param epp		Endpoint pair
  * @param acpass	Active/passive
  * @param oflags	Open flags
@@ -65,15 +65,21 @@
  * establishment.
  */
-tcp_error_t tcp_uc_open(tcp_sock_t *lsock, tcp_sock_t *fsock, acpass_t acpass,
+tcp_error_t tcp_uc_open(inet_ep2_t *epp, acpass_t acpass,
     tcp_open_flags_t oflags, tcp_conn_t **conn)
 {
 	tcp_conn_t *nconn;
-
-	log_msg(LOG_DEFAULT, LVL_DEBUG, "tcp_uc_open(%p, %p, %s, %s, %p)",
-	    lsock, fsock, acpass == ap_active ? "active" : "passive",
+	int rc;
+
+	log_msg(LOG_DEFAULT, LVL_DEBUG, "tcp_uc_open(%p, %s, %s, %p)",
+	    epp, acpass == ap_active ? "active" : "passive",
 	    oflags == tcp_open_nonblock ? "nonblock" : "none", conn);
 
-	nconn = tcp_conn_new(lsock, fsock);
-	tcp_conn_add(nconn);
+	nconn = tcp_conn_new(epp);
+	rc = tcp_conn_add(nconn);
+	if (rc != EOK) {
+		tcp_conn_delete(nconn);
+		return TCP_EEXISTS;
+	}
+
 	tcp_conn_lock(nconn);
 
@@ -188,4 +194,6 @@
 	/* Wait for data to become available */
 	while (conn->rcv_buf_used == 0 && !conn->rcv_buf_fin && !conn->reset) {
+		tcp_conn_unlock(conn);
+		return TCP_EAGAIN;
 		log_msg(LOG_DEFAULT, LVL_DEBUG, "tcp_uc_receive() - wait for data");
 		fibril_condvar_wait(&conn->rcv_buf_cv, &conn->lock);
@@ -250,5 +258,4 @@
 		log_msg(LOG_DEFAULT, LVL_DEBUG, "tcp_uc_close - listen/syn_sent");
 		tcp_conn_reset(conn);
-		tcp_conn_remove(conn);
 		tcp_conn_unlock(conn);
 		return TCP_EOK;
@@ -294,11 +301,16 @@
 }
 
-void tcp_uc_set_cstate_cb(tcp_conn_t *conn, tcp_cstate_cb_t cb, void *arg)
-{
-	log_msg(LOG_DEFAULT, LVL_DEBUG, "tcp_uc_set_ctate_cb(%p, %p, %p)",
+void tcp_uc_set_cb(tcp_conn_t *conn, tcp_cb_t *cb, void *arg)
+{
+	log_msg(LOG_DEFAULT, LVL_DEBUG, "tcp_uc_set_cb(%p, %p, %p)",
 	    conn, cb, arg);
 
-	conn->cstate_cb = cb;
-	conn->cstate_cb_arg = arg;
+	conn->cb = cb;
+	conn->cb_arg = arg;
+}
+
+void *tcp_uc_get_userptr(tcp_conn_t *conn)
+{
+	return conn->cb_arg;
 }
 
@@ -308,5 +320,5 @@
 
 /** Segment arrived */
-void tcp_as_segment_arrived(tcp_sockpair_t *sp, tcp_segment_t *seg)
+void tcp_as_segment_arrived(inet_ep2_t *epp, tcp_segment_t *seg)
 {
 	tcp_conn_t *conn;
@@ -314,35 +326,14 @@
 	log_msg(LOG_DEFAULT, LVL_DEBUG,
 	    "tcp_as_segment_arrived(f:(%u), l:(%u))",
-	    sp->foreign.port, sp->local.port);
-
-	conn = tcp_conn_find_ref(sp);
+	    epp->remote.port, epp->local.port);
+
+	conn = tcp_conn_find_ref(epp);
 	if (conn == NULL) {
 		log_msg(LOG_DEFAULT, LVL_WARN, "No connection found.");
-		tcp_unexpected_segment(sp, seg);
+		tcp_unexpected_segment(epp, seg);
 		return;
 	}
 
-	tcp_conn_lock(conn);
-
-	if (conn->cstate == st_closed) {
-		log_msg(LOG_DEFAULT, LVL_WARN, "Connection is closed.");
-		tcp_unexpected_segment(sp, seg);
-		tcp_conn_unlock(conn);
-		tcp_conn_delref(conn);
-		return;
-	}
-
-	if (inet_addr_is_any(&conn->ident.foreign.addr))
-		conn->ident.foreign.addr = sp->foreign.addr;
-	
-	if (conn->ident.foreign.port == TCP_PORT_ANY)
-		conn->ident.foreign.port = sp->foreign.port;
-	
-	if (inet_addr_is_any(&conn->ident.local.addr))
-		conn->ident.local.addr = sp->local.addr;
-
-	tcp_conn_segment_arrived(conn, seg);
-
-	tcp_conn_unlock(conn);
+	tcp_conn_segment_arrived(conn, epp, seg);
 	tcp_conn_delref(conn);
 }
Index: uspace/srv/net/tcp/ucall.h
===================================================================
--- uspace/srv/net/tcp/ucall.h	(revision fc7bf198e20e68849d91546bbc5a2a24c943840e)
+++ uspace/srv/net/tcp/ucall.h	(revision cf3aee195010da61f58b4c6e8daa8d03620c0a4e)
@@ -1,4 +1,4 @@
 /*
- * Copyright (c) 2011 Jiri Svoboda
+ * Copyright (c) 2015 Jiri Svoboda
  * All rights reserved.
  *
@@ -36,4 +36,5 @@
 #define UCALL_H
 
+#include <inet/endpoint.h>
 #include <sys/types.h>
 #include "tcp_type.h"
@@ -42,5 +43,5 @@
  * User calls
  */
-extern tcp_error_t tcp_uc_open(tcp_sock_t *, tcp_sock_t *, acpass_t,
+extern tcp_error_t tcp_uc_open(inet_ep2_t *, acpass_t,
     tcp_open_flags_t, tcp_conn_t **);
 extern tcp_error_t tcp_uc_send(tcp_conn_t *, void *, size_t, xflags_t);
@@ -50,10 +51,11 @@
 extern void tcp_uc_status(tcp_conn_t *, tcp_conn_status_t *);
 extern void tcp_uc_delete(tcp_conn_t *);
-extern void tcp_uc_set_cstate_cb(tcp_conn_t *, tcp_cstate_cb_t, void *);
+extern void tcp_uc_set_cb(tcp_conn_t *, tcp_cb_t *, void *);
+extern void *tcp_uc_get_userptr(tcp_conn_t *);
 
 /*
  * Arriving segments
  */
-extern void tcp_as_segment_arrived(tcp_sockpair_t *, tcp_segment_t *);
+extern void tcp_as_segment_arrived(inet_ep2_t *, tcp_segment_t *);
 
 /*
Index: uspace/srv/net/udp/Makefile
===================================================================
--- uspace/srv/net/udp/Makefile	(revision fc7bf198e20e68849d91546bbc5a2a24c943840e)
+++ uspace/srv/net/udp/Makefile	(revision cf3aee195010da61f58b4c6e8daa8d03620c0a4e)
@@ -28,6 +28,11 @@
 
 USPACE_PREFIX = ../../..
-LIBS = $(LIBNET_PREFIX)/libnet.a
-EXTRA_CFLAGS = -I$(LIBNET_PREFIX)/include
+
+LIBS = \
+	$(LIBNETTL_PREFIX)/libnettl.a
+
+EXTRA_CFLAGS += \
+	-I$(LIBNETTL_PREFIX)/include
+
 BINARY = udp
 
@@ -35,7 +40,6 @@
 	assoc.c \
 	msg.c \
-	sock.c \
 	pdu.c \
-	ucall.c \
+	service.c \
 	udp.c \
 	udp_inet.c
Index: uspace/srv/net/udp/assoc.c
===================================================================
--- uspace/srv/net/udp/assoc.c	(revision fc7bf198e20e68849d91546bbc5a2a24c943840e)
+++ uspace/srv/net/udp/assoc.c	(revision cf3aee195010da61f58b4c6e8daa8d03620c0a4e)
@@ -1,4 +1,4 @@
 /*
- * Copyright (c) 2012 Jiri Svoboda
+ * Copyright (c) 2015 Jiri Svoboda
  * All rights reserved.
  *
@@ -36,7 +36,10 @@
 
 #include <adt/list.h>
+#include <errno.h>
 #include <stdbool.h>
 #include <fibril_synch.h>
+#include <inet/endpoint.h>
 #include <io/log.h>
+#include <nettl/amap.h>
 #include <stdlib.h>
 
@@ -44,23 +47,36 @@
 #include "msg.h"
 #include "pdu.h"
-#include "ucall.h"
 #include "udp_inet.h"
 #include "udp_type.h"
 
-LIST_INITIALIZE(assoc_list);
-FIBRIL_MUTEX_INITIALIZE(assoc_list_lock);
-
-static udp_assoc_t *udp_assoc_find_ref(udp_sockpair_t *);
-static int udp_assoc_queue_msg(udp_assoc_t *, udp_sockpair_t *, udp_msg_t *);
-static bool udp_socket_match(udp_sock_t *, udp_sock_t *);
-static bool udp_sockpair_match(udp_sockpair_t *, udp_sockpair_t *);
+static LIST_INITIALIZE(assoc_list);
+static FIBRIL_MUTEX_INITIALIZE(assoc_list_lock);
+static amap_t *amap;
+
+static udp_assoc_t *udp_assoc_find_ref(inet_ep2_t *);
+static int udp_assoc_queue_msg(udp_assoc_t *, inet_ep2_t *, udp_msg_t *);
+
+/** Initialize associations. */
+int udp_assocs_init(void)
+{
+	int rc;
+
+	rc = amap_create(&amap);
+	if (rc != EOK) {
+		assert(rc == ENOMEM);
+		return ENOMEM;
+	}
+
+	return EOK;
+}
 
 /** Create new association structure.
  *
- * @param lsock		Local socket (will be deeply copied)
- * @param fsock		Foreign socket (will be deeply copied)
+ * @param epp		Endpoint pair (will be copied)
+ * @param cb		Callbacks
+ * @param cb_arg	Callback argument
  * @return		New association or NULL
  */
-udp_assoc_t *udp_assoc_new(udp_sock_t *lsock, udp_sock_t *fsock)
+udp_assoc_t *udp_assoc_new(inet_ep2_t *epp, udp_assoc_cb_t *cb, void *cb_arg)
 {
 	udp_assoc_t *assoc = NULL;
@@ -80,10 +96,9 @@
 	fibril_condvar_initialize(&assoc->rcv_queue_cv);
 
-	if (lsock != NULL)
-		assoc->ident.local = *lsock;
-	
-	if (fsock != NULL)
-		assoc->ident.foreign = *fsock;
-
+	if (epp != NULL)
+		assoc->ident = *epp;
+
+	assoc->cb = cb;
+	assoc->cb_arg = cb_arg;
 	return assoc;
 error:
@@ -166,10 +181,24 @@
  * Add association to the association map.
  */
-void udp_assoc_add(udp_assoc_t *assoc)
-{
+int udp_assoc_add(udp_assoc_t *assoc)
+{
+	inet_ep2_t aepp;
+	int rc;
+
 	udp_assoc_addref(assoc);
 	fibril_mutex_lock(&assoc_list_lock);
+
+	rc = amap_insert(amap, &assoc->ident, assoc, af_allow_system, &aepp);
+	if (rc != EOK) {
+		udp_assoc_delref(assoc);
+		fibril_mutex_unlock(&assoc_list_lock);
+		return rc;
+	}
+
+	assoc->ident = aepp;
 	list_append(&assoc->link, &assoc_list);
 	fibril_mutex_unlock(&assoc_list_lock);
+
+	return EOK;
 }
 
@@ -181,4 +210,5 @@
 {
 	fibril_mutex_lock(&assoc_list_lock);
+	amap_remove(amap, &assoc->ident);
 	list_remove(&assoc->link);
 	fibril_mutex_unlock(&assoc_list_lock);
@@ -196,82 +226,52 @@
 	    assoc, iplink);
 	fibril_mutex_lock(&assoc->lock);
-	assoc->ident.iplink = iplink;
+	assoc->ident.local_link = iplink;
 	fibril_mutex_unlock(&assoc->lock);
 }
 
-/** Set foreign socket in association.
- *
- * @param assoc		Association
- * @param fsock		Foreign socket (deeply copied)
- */
-void udp_assoc_set_foreign(udp_assoc_t *assoc, udp_sock_t *fsock)
-{
-	log_msg(LOG_DEFAULT, LVL_DEBUG, "udp_assoc_set_foreign(%p, %p)", assoc, fsock);
-	fibril_mutex_lock(&assoc->lock);
-	assoc->ident.foreign = *fsock;
-	fibril_mutex_unlock(&assoc->lock);
-}
-
-/** Set local socket in association.
- *
- * @param assoc Association
- * @param lsock Local socket (deeply copied)
- *
- */
-void udp_assoc_set_local(udp_assoc_t *assoc, udp_sock_t *lsock)
-{
-	log_msg(LOG_DEFAULT, LVL_DEBUG, "udp_assoc_set_local(%p, %p)", assoc, lsock);
-	fibril_mutex_lock(&assoc->lock);
-	assoc->ident.local = *lsock;
-	fibril_mutex_unlock(&assoc->lock);
-}
-
-/** Set local port in association.
- *
- * @param assoc Association
- * @param lport Local port
- *
- */
-void udp_assoc_set_local_port(udp_assoc_t *assoc, uint16_t lport)
-{
-	log_msg(LOG_DEFAULT, LVL_DEBUG, "udp_assoc_set_local(%p, %" PRIu16 ")", assoc, lport);
-	fibril_mutex_lock(&assoc->lock);
-	assoc->ident.local.port = lport;
-	fibril_mutex_unlock(&assoc->lock);
-}
-
 /** Send message to association.
  *
  * @param assoc		Association
- * @param fsock		Foreign socket or NULL not to override @a assoc
+ * @param remote	Remote endpoint or NULL not to override @a assoc
  * @param msg		Message
  *
  * @return		EOK on success
- *			EINVAL if foreign socket is not set
+ *			EINVAL if remote endpoint is not set
  *			ENOMEM if out of resources
  *			EIO if no route to destination exists
  */
-int udp_assoc_send(udp_assoc_t *assoc, udp_sock_t *fsock, udp_msg_t *msg)
+int udp_assoc_send(udp_assoc_t *assoc, inet_ep_t *remote, udp_msg_t *msg)
 {
 	udp_pdu_t *pdu;
-	udp_sockpair_t sp;
+	inet_ep2_t epp;
 	int rc;
 
 	log_msg(LOG_DEFAULT, LVL_DEBUG, "udp_assoc_send(%p, %p, %p)",
-	    assoc, fsock, msg);
-
-	/* @a fsock can be used to override the foreign socket */
-	sp = assoc->ident;
-	if (fsock != NULL)
-		sp.foreign = *fsock;
-
-	if ((inet_addr_is_any(&sp.foreign.addr)) ||
-	    (sp.foreign.port == UDP_PORT_ANY))
+	    assoc, remote, msg);
+
+	/* @a remote can be used to override the remote endpoint */
+	epp = assoc->ident;
+	if (remote != NULL)
+		epp.remote = *remote;
+
+	log_msg(LOG_DEFAULT, LVL_DEBUG, "udp_assoc_send - check addr any");
+
+	if ((inet_addr_is_any(&epp.remote.addr)) ||
+	    (epp.remote.port == inet_port_any))
 		return EINVAL;
 
-	rc = udp_pdu_encode(&sp, msg, &pdu);
+	log_msg(LOG_DEFAULT, LVL_DEBUG, "udp_assoc_send - check version");
+
+	if (epp.remote.addr.version != epp.local.addr.version)
+		return EINVAL;
+
+	log_msg(LOG_DEFAULT, LVL_DEBUG, "udp_assoc_send - encode pdu");
+
+	rc = udp_pdu_encode(&epp, msg, &pdu);
 	if (rc != EOK)
 		return ENOMEM;
 
+	log_msg(LOG_DEFAULT, LVL_DEBUG, "udp_assoc_send - transmit");
+
 	rc = udp_transmit_pdu(pdu);
 	udp_pdu_delete(pdu);
@@ -280,4 +280,5 @@
 		return EIO;
 
+	log_msg(LOG_DEFAULT, LVL_DEBUG, "udp_assoc_send - success");
 	return EOK;
 }
@@ -287,5 +288,5 @@
  * Pull one message from the association's receive queue.
  */
-int udp_assoc_recv(udp_assoc_t *assoc, udp_msg_t **msg, udp_sock_t *fsock)
+int udp_assoc_recv(udp_assoc_t *assoc, udp_msg_t **msg, inet_ep_t *remote)
 {
 	link_t *link;
@@ -303,5 +304,5 @@
 		log_msg(LOG_DEFAULT, LVL_DEBUG, "udp_assoc_recv() - association was reset");
 		fibril_mutex_unlock(&assoc->lock);
-		return ECONNABORTED;
+		return ENXIO;
 	}
 
@@ -313,5 +314,5 @@
 
 	*msg = rqe->msg;
-	*fsock = rqe->sp.foreign;
+	*remote = rqe->epp.remote;
 	free(rqe);
 
@@ -323,12 +324,12 @@
  * Find the association to which the message belongs and queue it.
  */
-void udp_assoc_received(udp_sockpair_t *rsp, udp_msg_t *msg)
+void udp_assoc_received(inet_ep2_t *repp, udp_msg_t *msg)
 {
 	udp_assoc_t *assoc;
 	int rc;
 
-	log_msg(LOG_DEFAULT, LVL_DEBUG, "udp_assoc_received(%p, %p)", rsp, msg);
-
-	assoc = udp_assoc_find_ref(rsp);
+	log_msg(LOG_DEFAULT, LVL_DEBUG, "udp_assoc_received(%p, %p)", repp, msg);
+
+	assoc = udp_assoc_find_ref(repp);
 	if (assoc == NULL) {
 		log_msg(LOG_DEFAULT, LVL_DEBUG, "No association found. Message dropped.");
@@ -339,9 +340,15 @@
 	}
 
-	rc = udp_assoc_queue_msg(assoc, rsp, msg);
-	if (rc != EOK) {
-		log_msg(LOG_DEFAULT, LVL_DEBUG, "Out of memory. Message dropped.");
+	if (0) {
+		rc = udp_assoc_queue_msg(assoc, repp, msg);
+		if (rc != EOK) {
+			log_msg(LOG_DEFAULT, LVL_DEBUG, "Out of memory. Message dropped.");
 		/* XXX Generate ICMP error? */
-	}
+		}
+	}
+
+	log_msg(LOG_DEFAULT, LVL_DEBUG, "call assoc->cb->recv_msg");
+	assoc->cb->recv_msg(assoc->cb_arg, repp, msg);
+	udp_assoc_delref(assoc);
 }
 
@@ -359,5 +366,5 @@
 }
 
-static int udp_assoc_queue_msg(udp_assoc_t *assoc, udp_sockpair_t *sp,
+static int udp_assoc_queue_msg(udp_assoc_t *assoc, inet_ep2_t *epp,
     udp_msg_t *msg)
 {
@@ -365,5 +372,5 @@
 
 	log_msg(LOG_DEFAULT, LVL_DEBUG, "udp_assoc_queue_msg(%p, %p, %p)",
-	    assoc, sp, msg);
+	    assoc, epp, msg);
 
 	rqe = calloc(1, sizeof(udp_rcv_queue_entry_t));
@@ -372,5 +379,5 @@
 
 	link_initialize(&rqe->link);
-	rqe->sp = *sp;
+	rqe->epp = *epp;
 	rqe->msg = msg;
 
@@ -384,71 +391,34 @@
 }
 
-/** Match socket with pattern. */
-static bool udp_socket_match(udp_sock_t *sock, udp_sock_t *patt)
-{
-	log_msg(LOG_DEFAULT, LVL_DEBUG,
-	    "udp_socket_match(sock=(%u), pat=(%u))", sock->port, patt->port);
-	
-	if ((!inet_addr_is_any(&patt->addr)) &&
-	    (!inet_addr_compare(&patt->addr, &sock->addr)))
-		return false;
-	
-	if ((patt->port != UDP_PORT_ANY) &&
-	    (patt->port != sock->port))
-		return false;
-	
-	log_msg(LOG_DEFAULT, LVL_DEBUG, " -> match");
-	
-	return true;
-}
-
-/** Match socket pair with pattern. */
-static bool udp_sockpair_match(udp_sockpair_t *sp, udp_sockpair_t *pattern)
-{
-	log_msg(LOG_DEFAULT, LVL_DEBUG, "udp_sockpair_match(%p, %p)", sp, pattern);
-
-	if (!udp_socket_match(&sp->local, &pattern->local))
-		return false;
-
-	if (!udp_socket_match(&sp->foreign, &pattern->foreign))
-		return false;
-
-	log_msg(LOG_DEFAULT, LVL_DEBUG, "Socket pair matched.");
-	return true;
-}
-
-
-/** Find association structure for specified socket pair.
- *
- * An association is uniquely identified by a socket pair. Look up our
- * association map and return association structure based on socket pair.
+/** Find association structure for specified endpoint pair.
+ *
+ * An association is uniquely identified by an endpoint pair. Look up our
+ * association map and return association structure based on endpoint pair.
  * The association reference count is bumped by one.
  *
- * @param sp	Socket pair
+ * @param epp	Endpoint pair
  * @return	Association structure or NULL if not found.
  */
-static udp_assoc_t *udp_assoc_find_ref(udp_sockpair_t *sp)
-{
-	log_msg(LOG_DEFAULT, LVL_DEBUG, "udp_assoc_find_ref(%p)", sp);
-	
+static udp_assoc_t *udp_assoc_find_ref(inet_ep2_t *epp)
+{
+	int rc;
+	void *arg;
+	udp_assoc_t *assoc;
+
+	log_msg(LOG_DEFAULT, LVL_DEBUG, "udp_assoc_find_ref(%p)", epp);
 	fibril_mutex_lock(&assoc_list_lock);
-	
-	list_foreach(assoc_list, link, udp_assoc_t, assoc) {
-		udp_sockpair_t *asp = &assoc->ident;
-		
-		/* Skip unbound associations */
-		if (asp->local.port == UDP_PORT_ANY)
-			continue;
-		
-		if (udp_sockpair_match(sp, asp)) {
-			log_msg(LOG_DEFAULT, LVL_DEBUG, "Returning assoc %p", assoc);
-			udp_assoc_addref(assoc);
-			fibril_mutex_unlock(&assoc_list_lock);
-			return assoc;
-		}
-	}
-	
+
+	rc = amap_find_match(amap, epp, &arg);
+	if (rc != EOK) {
+		assert(rc == ENOMEM);
+		fibril_mutex_unlock(&assoc_list_lock);
+		return NULL;
+	}
+
+	assoc = (udp_assoc_t *)arg;
+	udp_assoc_addref(assoc);
+
 	fibril_mutex_unlock(&assoc_list_lock);
-	return NULL;
+	return assoc;
 }
 
Index: uspace/srv/net/udp/assoc.h
===================================================================
--- uspace/srv/net/udp/assoc.h	(revision fc7bf198e20e68849d91546bbc5a2a24c943840e)
+++ uspace/srv/net/udp/assoc.h	(revision cf3aee195010da61f58b4c6e8daa8d03620c0a4e)
@@ -1,4 +1,4 @@
 /*
- * Copyright (c) 2012 Jiri Svoboda
+ * Copyright (c) 2015 Jiri Svoboda
  * All rights reserved.
  *
@@ -36,21 +36,20 @@
 #define ASSOC_H
 
+#include <inet/endpoint.h>
 #include <ipc/loc.h>
 #include <sys/types.h>
 #include "udp_type.h"
 
-extern udp_assoc_t *udp_assoc_new(udp_sock_t *, udp_sock_t *);
+extern int udp_assocs_init(void);
+extern udp_assoc_t *udp_assoc_new(inet_ep2_t *, udp_assoc_cb_t *, void *);
 extern void udp_assoc_delete(udp_assoc_t *);
-extern void udp_assoc_add(udp_assoc_t *);
+extern int udp_assoc_add(udp_assoc_t *);
 extern void udp_assoc_remove(udp_assoc_t *);
 extern void udp_assoc_addref(udp_assoc_t *);
 extern void udp_assoc_delref(udp_assoc_t *);
 extern void udp_assoc_set_iplink(udp_assoc_t *, service_id_t);
-extern void udp_assoc_set_foreign(udp_assoc_t *, udp_sock_t *);
-extern void udp_assoc_set_local(udp_assoc_t *, udp_sock_t *);
-extern void udp_assoc_set_local_port(udp_assoc_t *, uint16_t);
-extern int udp_assoc_send(udp_assoc_t *, udp_sock_t *, udp_msg_t *);
-extern int udp_assoc_recv(udp_assoc_t *, udp_msg_t **, udp_sock_t *);
-extern void udp_assoc_received(udp_sockpair_t *, udp_msg_t *);
+extern int udp_assoc_send(udp_assoc_t *, inet_ep_t *, udp_msg_t *);
+extern int udp_assoc_recv(udp_assoc_t *, udp_msg_t **, inet_ep_t *);
+extern void udp_assoc_received(inet_ep2_t *, udp_msg_t *);
 extern void udp_assoc_reset(udp_assoc_t *);
 
Index: uspace/srv/net/udp/msg.c
===================================================================
--- uspace/srv/net/udp/msg.c	(revision fc7bf198e20e68849d91546bbc5a2a24c943840e)
+++ uspace/srv/net/udp/msg.c	(revision cf3aee195010da61f58b4c6e8daa8d03620c0a4e)
@@ -50,4 +50,5 @@
 void udp_msg_delete(udp_msg_t *msg)
 {
+	free(msg->data);
 	free(msg);
 }
Index: uspace/srv/net/udp/pdu.c
===================================================================
--- uspace/srv/net/udp/pdu.c	(revision fc7bf198e20e68849d91546bbc5a2a24c943840e)
+++ uspace/srv/net/udp/pdu.c	(revision cf3aee195010da61f58b4c6e8daa8d03620c0a4e)
@@ -1,4 +1,4 @@
 /*
- * Copyright (c) 2012 Jiri Svoboda
+ * Copyright (c) 2015 Jiri Svoboda
  * All rights reserved.
  *
@@ -41,5 +41,4 @@
 #include <stdlib.h>
 #include <inet/addr.h>
-#include <net/socket_codes.h>
 #include "msg.h"
 #include "pdu.h"
@@ -163,5 +162,5 @@
 
 /** Decode incoming PDU */
-int udp_pdu_decode(udp_pdu_t *pdu, udp_sockpair_t *sp, udp_msg_t **msg)
+int udp_pdu_decode(udp_pdu_t *pdu, inet_ep2_t *epp, udp_msg_t **msg)
 {
 	udp_msg_t *nmsg;
@@ -180,8 +179,9 @@
 	hdr = (udp_header_t *)pdu->data;
 
-	sp->foreign.port = uint16_t_be2host(hdr->src_port);
-	sp->foreign.addr = pdu->src;
-	sp->local.port = uint16_t_be2host(hdr->dest_port);
-	sp->local.addr = pdu->dest;
+	epp->local_link = pdu->iplink;
+	epp->remote.port = uint16_t_be2host(hdr->src_port);
+	epp->remote.addr = pdu->src;
+	epp->local.port = uint16_t_be2host(hdr->dest_port);
+	epp->local.addr = pdu->dest;
 
 	length = uint16_t_be2host(hdr->length);
@@ -197,6 +197,10 @@
 		return ENOMEM;
 
-	nmsg->data = text;
 	nmsg->data_size = length - sizeof(udp_header_t);
+	nmsg->data = malloc(nmsg->data_size);
+	if (nmsg->data == NULL)
+		return ENOMEM;
+
+	memcpy(nmsg->data, text, nmsg->data_size);
 
 	*msg = nmsg;
@@ -205,5 +209,5 @@
 
 /** Encode outgoing PDU */
-int udp_pdu_encode(udp_sockpair_t *sp, udp_msg_t *msg, udp_pdu_t **pdu)
+int udp_pdu_encode(inet_ep2_t *epp, udp_msg_t *msg, udp_pdu_t **pdu)
 {
 	udp_pdu_t *npdu;
@@ -215,7 +219,7 @@
 		return ENOMEM;
 
-	npdu->iplink = sp->iplink;
-	npdu->src = sp->local.addr;
-	npdu->dest = sp->foreign.addr;
+	npdu->iplink = epp->local_link;
+	npdu->src = epp->local.addr;
+	npdu->dest = epp->remote.addr;
 
 	npdu->data_size = sizeof(udp_header_t) + msg->data_size;
@@ -227,6 +231,6 @@
 
 	hdr = (udp_header_t *)npdu->data;
-	hdr->src_port = host2uint16_t_be(sp->local.port);
-	hdr->dest_port = host2uint16_t_be(sp->foreign.port);
+	hdr->src_port = host2uint16_t_be(epp->local.port);
+	hdr->dest_port = host2uint16_t_be(epp->remote.port);
 	hdr->length = host2uint16_t_be(npdu->data_size);
 	hdr->checksum = 0;
Index: uspace/srv/net/udp/pdu.h
===================================================================
--- uspace/srv/net/udp/pdu.h	(revision fc7bf198e20e68849d91546bbc5a2a24c943840e)
+++ uspace/srv/net/udp/pdu.h	(revision cf3aee195010da61f58b4c6e8daa8d03620c0a4e)
@@ -1,4 +1,4 @@
 /*
- * Copyright (c) 2012 Jiri Svoboda
+ * Copyright (c) 2015 Jiri Svoboda
  * All rights reserved.
  *
@@ -36,4 +36,5 @@
 #define PDU_H
 
+#include <inet/endpoint.h>
 #include <sys/types.h>
 #include "std.h"
@@ -42,6 +43,6 @@
 extern udp_pdu_t *udp_pdu_new(void);
 extern void udp_pdu_delete(udp_pdu_t *);
-extern int udp_pdu_decode(udp_pdu_t *, udp_sockpair_t *, udp_msg_t **);
-extern int udp_pdu_encode(udp_sockpair_t *, udp_msg_t *, udp_pdu_t **);
+extern int udp_pdu_decode(udp_pdu_t *, inet_ep2_t *, udp_msg_t **);
+extern int udp_pdu_encode(inet_ep2_t *, udp_msg_t *, udp_pdu_t **);
 
 #endif
